-module(spoke@internal@packet).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export_type([qo_s/0, message_data/0, auth_options/0, connect_options/0, publish_data/0, subscribe_request/0, connect_error/0]).

-if(?OTP_RELEASE >= 27).
-define(MODULEDOC(Str), -moduledoc(Str)).
-define(DOC(Str), -doc(Str)).
-else.
-define(MODULEDOC(Str), -compile([])).
-define(DOC(Str), -compile([])).
-endif.

?MODULEDOC(false).

-type qo_s() :: qo_s0 | qo_s1 | qo_s2.

-type message_data() :: {message_data, binary(), bitstring(), boolean()}.

-type auth_options() :: {auth_options,
        binary(),
        gleam@option:option(bitstring())}.

-type connect_options() :: {connect_options,
        boolean(),
        binary(),
        integer(),
        gleam@option:option(auth_options()),
        gleam@option:option({message_data(), qo_s()})}.

-type publish_data() :: {publish_data_qo_s0, message_data()} |
    {publish_data_qo_s1, message_data(), boolean(), integer()} |
    {publish_data_qo_s2, message_data(), boolean(), integer()}.

-type subscribe_request() :: {subscribe_request, binary(), qo_s()}.

-type connect_error() :: unacceptable_protocol_version |
    identifier_refused |
    server_unavailable |
    bad_username_or_password |
    not_authorized.


